"{ Package: 'jv:tea/compiler' }"

"{ NameSpace: Smalltalk }"

TValueBinding subclass:#TVariableBinding
	instanceVariableNames:'name'
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-Tea-Compiler-Bindings'
!

!TVariableBinding class methodsFor:'instance creation'!

type:aTType name:aString 
    ^ self new initializeWithType:aTType name:aString

    "Created: / 25-08-2015 / 22:46:00 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!TVariableBinding class methodsFor:'queries'!

isAbstract
    "Return if this class is an abstract class.
     True is returned here for myself only; false for subclasses.
     Abstract subclasses must redefine again."

    ^ self == TVariableBinding.
! !

!TVariableBinding methodsFor:'accessing'!

name
    ^ name
! !

!TVariableBinding methodsFor:'initialization'!

initializeWithType:aTType name:aString 
    name := aString.
    type := aTType.

    "Created: / 25-08-2015 / 22:45:27 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!TVariableBinding methodsFor:'printing & storing'!

printOn:aStream
    aStream nextPutAll: name.
    aStream space.
    type notNil ifTrue:[ 
        type printOn: aStream
    ] ifFalse:[ 
        aStream nextPutAll: '< ??? >'
    ].

    "Modified: / 25-08-2015 / 22:54:09 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

